
#include "inc/LaserRangeFinder.h"

// init, terminate
void lrf_init() {
    char port[] = "/dev/????????";

    FILE* fp = popen("dmesg | grep -A 3 \"Arduino Uno\"  | grep -o \"ttyACM.\" | tail -n 1","r");
    fgets(port+5, sizeof(port)-6, fp);
    printf("Port: %s\n", port);
    pclose(fp);

    uart_setup(port);
}

void lrf_term() {
    uart_close();
}

// getters
GEN_TYPE_boolean lrf_is_noval() {
    return false;
}

GEN_TYPE_int lrf_read() {
    char bytes[5];
    int n_read = 0;

    char value[3];
    int n = 0;

    int i;

    int d;

    // free buffer
    uart_flush();

    // looks like a blocking call and actually is but is always very fast
    // since it only has to read the queue
    while (1) {
        n_read = uart_receive(&bytes, 5, 0);

        for (i = 0; i < n_read; i++) {
            if (bytes[i] != 0xd && bytes[i] != 0xa) {
                value[n++] = bytes[i];
            } else if (atoi(value) != 0) {
                d = atoi(value);
                for (i = n; i < 3; i++) {
                    value[i] = 0;
                }
                return d;
            }
        }
    }
}
